const
  TER_CLOSE                              = (WM_USER + 1700);
  TER_MODIFIED                           = (WM_USER + 1701);
  TER_LINK                               = (WM_USER + 1702);
  TER_MERGE                              = (WM_USER + 1703);
  TER_NOT_SAVED                          = (WM_USER + 1704);
  TER_UPDATE_TOOLBAR                     = (WM_USER + 1705);
  TER_UPDATE_STATUSBAR                   = (WM_USER + 1706);
  TER_ACTION                             = (WM_USER + 1707);
  TER_PREPROCESS                         = (WM_USER + 1708);
  TER_XLATE_PICT                         = (WM_USER + 1709);
  TER_HTML_SIZE                          = (WM_USER + 1710);
  TER_ANIM_PICT                          = (WM_USER + 1711);
  TER_REPAINT                            = (WM_USER + 1712);
  TER_DROP                               = (WM_USER + 1713);
  TER_DRAG                               = (WM_USER + 1714);
  TER_BEFORE_DROP                        = (WM_USER + 1715);
  TER_PAGE_SIZE_CHANGING                 = (WM_USER + 1716);
  TER_CREATED                            = (WM_USER + 1717);
  TER_SAVE_UNDO                          = (WM_USER + 1718);
  TER_USER_FIELD1                        = (WM_USER + 1719);
  TER_BKND_PICT                          = (WM_USER + 1720);
  TER_USER_DROP                          = (WM_USER + 1721);
  TER_FONT_CHECK                         = (WM_USER + 1722);
  TER_UNI_CHAR                           = (WM_USER + 1723);
  TER_ADJUST_COLOR                       = (WM_USER + 1724);
  TER_DRAGON                             = (WM_USER + 1725);
  TER_RESOLVE_IMAGE_PATH                 = (WM_USER + 1726);
  TER_TSF_NEW_TEXT                       = (WM_USER + 1727);
  TER_TSF_PHRASE_ENDED                   = (WM_USER + 1728);

const
  TER_WORD_WRAP                          = $0001;
  TER_PRINT_VIEW                         = $0002;
  TER_HSCROLL                            = $0004;
  TER_VSCROLL                            = $0008;
  TER_SHOW_STATUS                        = $0010;
  TER_SHOW_RULER                         = $0020;
  TER_BORDER_MARGIN                      = $0040;
  TER_OUTPUT_RTF                         = $0080;
  TER_USE_PARAMS                         = $0100;
  TER_READ_ONLY                          = $0200;
  TER_PAGE_MODE                          = $0400;
  TER_SHOW_TOOLBAR                       = $0800;
  TER_INVISIBLE                          = $1000;
  TER_FITTED_VIEW                        = $2000;
  TER_DESIGN_MODE                        = $4000;
  TER_USE_EXT_STYLES                     = $8000;

const
  ACTION_COMMAND                         = 01;
  ACTION_VSCROLL                         = 02;
  ACTION_HSCROLL                         = 03;
  ACTION_CHAR                            = 04;
  ACTION_LBUTTONDOWN                     = 05;
  ACTION_RBUTTONDOWN                     = 06;
  ACTION_LBUTTONUP                       = 07;
  ACTION_RBUTTONUP                       = 08;
  ACTION_LBUTTONDBLCLK                   = 09;
  ACTION_RBUTTONDBLCLK                   = 10;
  ACTION_SIZE                            = 11;
  ACTION_SETFOCUS                        = 12;
  ACTION_KILLFOCUS                       = 13;
  ACTION_MOUSEMOVE                       = 14;
  ACTION_QUERYENDSESSION                 = 15;
  ACTION_CHECKBOX                        = 16;
  ACTION_MOUSELEAVE                      = 17;
  ACTION_MBUTTONDOWN                     = 18;
  ACTION_MBUTTONUP                       = 19;
  ACTION_MBUTTONDBLCLK                   = 20;
  ACTION_ROW_INDENT                      = 21;
  ACTION_ROW_HEIGHT                      = 22;
  ACTION_CELL_WIDTH                      = 23;
  ACTION_PICT_SIZE                       = 24;
  ACTION_FRAME_SIZE                      = 25;
  ACTION_REPLACESEL                      = 26;
  ACTION_DRAG_DEL                        = 27;
  ACTION_DRAGON                          = 28;

const
  FIELD_PAGE_NUMBER                      = 01;
  FIELD_TEXTBOX                          = 02;
  FIELD_CHECKBOX                         = 03;
  FIELD_LISTBOX                          = 04;
  FIELD_COMBOBOX                         = 04;
  FIELD_PAGE_COUNT                       = 05;
  FIELD_NAME                             = 06;
  FIELD_DATA                             = 07;
  FIELD_DATE                             = 08;
  FIELD_TOC                              = 09;
  FIELD_PRINTDATE                        = 10;
  FIELD_LISTNUM                          = 11;
  FIELD_AUTONUMLGL                       = 12;
  FIELD_TC                               = 13;
  FIELD_HLINK                            = 14;
  FIELD_XE                               = 15;
  FIELD_PAGE_REF                         = 16;
  FIELD_SECT_PAGE_COUNT                  = 17;
  FIELD_USER1                            = 18;
  FIELD_REF                              = 19;
  FIELD_INCLUDEPICTURE                   = 20;
  FIELD_SEQ                              = 21;
  FIELD_FILE_NAME                        = 22;
  FIELD_FORMULA                          = 23;
  FIELD_DOC_PROP                         = 24;
  FIELD_TIME                             = 25;

const
  ID_PGUP                                = 600;
  ID_PGDN                                = 601;
  ID_UP                                  = 602;
  ID_DOWN                                = 603;
  ID_LEFT                                = 604;
  ID_RIGHT                               = 605;
  ID_DEL                                 = 606;
  ID_TAB                                 = 608;
  ID_BACK_TAB                            = 609;
  ID_LINE_BEGIN                          = 610;
  ID_LINE_END                            = 611;
  ID_FILE_BEGIN                          = 612;
  ID_FILE_END                            = 613;
  ID_CTRL_TAB                            = 614;
  ID_INS_AFT                             = 615;
  ID_INS_BEF                             = 616;
  ID_DEL_LINE                            = 617;
  ID_SPLIT_LINE                          = 618;
  ID_JOIN_LINE                           = 619;
  ID_NEXT_WORD                           = 620;
  ID_PREV_WORD                           = 621;
  ID_HILIGHT_LINE                        = 622;
  ID_BLOCK_COPY                          = 623;
  ID_BLOCK_MOVE                          = 624;
  ID_SELECT_ALL                          = 625;
  ID_NEW                                 = 626;
  ID_OPEN                                = 627;
  ID_CUT                                 = 628;
  ID_COPY                                = 629;
  ID_PASTE                               = 630;
  ID_PASTE_SPEC                          = 631;

  ID_PICT_FROM_FILE                      = 632;
  ID_EMBED_PICT                          = 632;

  ID_SEARCH                              = 633;
  ID_SEARCH_FOR                          = 634;
  ID_SEARCH_BACK                         = 635;
  ID_REPLACE                             = 636;
  ID_TER_HELP                            = 637;
  ID_UNDO                                = 638;
  ID_INSERT                              = 639;
  ID_SAVE                                = 640;
  ID_SAVEAS                              = 641;
  ID_QUIT                                = 642;
  ID_PRINT                               = 643;
  ID_PAGE_OPTIONS                        = 644;
  ID_PRINT_OPTIONS                       = 645;
  ID_JUMP                                = 646;

  ID_CHAR_NORMAL                         = 647;
  ID_BOLD_ON                             = 648;
  ID_ULINE_ON                            = 649;
  ID_ITALIC_ON                           = 650;
  ID_STRIKE_ON                           = 651;
  ID_SUPSCR_ON                           = 652;
  ID_SUBSCR_ON                           = 653;

  ID_COLOR                               = 654;

  ID_FONTS                               = 655;

  ID_PARA_NORMAL                         = 656;
  ID_CENTER                              = 657;
  ID_RIGHT_JUSTIFY                       = 658;
  ID_LEFT_INDENT                         = 659;
  ID_RIGHT_INDENT                        = 660;
  ID_DOUBLE_SPACE                        = 661;
  ID_HANGING_INDENT                      = 662;
  ID_JUSTIFY                             = 663;

  ID_TAB_CLEAR                           = 666;
  ID_TAB_CLEAR_ALL                       = 667;

  ID_PAGE_BREAK                          = 670;
  ID_REPAGINATE                          = 671;
  ID_SECT_BREAK                          = 672;
  ID_SECT_OPTIONS                        = 673;
  ID_PAGE_MODE                           = 674;
  ID_COL_BREAK                           = 675;
  ID_VIEW_HDR_FTR                        = 676;
  ID_EDIT_HDR_FTR                        = 677;

  ID_RULER                               = 680;
  ID_TOOL_BAR                            = 681;
  ID_STATUS_RIBBON                       = 682;

  ID_EDIT_PICT                           = 685;
  ID_SHOW_HIDDEN                         = 686;
  ID_HIDDEN_ON                           = 687;
  ID_ULINED_ON                           = 688;
  ID_PROTECT_ON                          = 689;
  ID_PROTECTION_LOCK                     = 690;

  ID_PARA_BORDER                         = 691;
  ID_SHOW_PARA_MARK                      = 692;
  ID_INSERT_OBJECT                       = 693;

  ID_TABLE_INSERT                        = 694;
  ID_TABLE_INSERT_ROW                    = 695;
  ID_TABLE_SPLIT_CELL                    = 696;
  ID_TABLE_MERGE_CELLS                   = 697;
  ID_TABLE_DEL_CELLS                     = 698;
  ID_TABLE_SHOW_GRID                     = 699;
  ID_TABLE_ROW_POS                       = 700;
  ID_TABLE_CELL_BORDER                   = 701;
  ID_TABLE_CELL_SHADE                    = 702;
  ID_TABLE_ROW_HEIGHT                    = 703;
  ID_TABLE_INSERT_COL                    = 704;
  ID_TABLE_SPLIT_CELL_VERT               = 705;

  ID_SHOW_HYPERLINK_CURSOR               = 710;
  ID_BK_COLOR                            = 711;

  ID_CTRL_UP                             = 715;
  ID_CTRL_DOWN                           = 716;
  ID_PRINT_PREVIEW                       = 717;

  ID_INSERT_PARA_FRAME                   = 718;
  ID_INSERT_PAGE_NUMBER                  = 719;

  ID_PARA_SPACING                        = 720;
  ID_INSERT_FNOTE                        = 721;
  ID_EDIT_FNOTE                          = 722;
  ID_PARA_KEEP                           = 723;
  ID_PARA_KEEP_NEXT                      = 724;
  ID_BOX_ON                              = 725;
  ID_INSERT_DRAW_OBJECT                  = 726;

  ID_EDIT_OLE                            = 727;
  ID_SNAP_TO_GRID                        = 728;
  ID_BULLET                              = 729;

  ID_EDIT_STYLE                          = 730;
  ID_CHAR_STYLE                          = 731;
  ID_PARA_STYLE                          = 732;
  ID_ZOOM                                = 733;
  ID_TAB_SET                             = 734;
  ID_FRAME_YBASE                         = 735;
  ID_EDIT_DOB                            = 736;
  ID_BKND_PICT                           = 737;
  ID_LINK_PICT                           = 738;

  ID_FITTED_VIEW                         = 739;
  ID_INSERT_NBSPACE                      = 740;
  ID_SPELL                               = 741;
  ID_HLINK_ON                            = 742;
  ID_WIDOW_ORPHAN                        = 743;

  ID_SHOW_PAGE_BORDER                    = 744;
  ID_SHOW_LAYOUT                         = 744;
  ID_SHOW_PAGE_LAYOUT                    = 744;

  ID_DEL_PREV_WORD                       = 745;
  ID_INSERT_NBDASH                       = 746;
  ID_REDO                                = 747;
  ID_PARA_NBR                            = 748;
  ID_PARA_BK_COLOR                       = 749;

  ID_TABLE_CELL_VALIGN                   = 750;
  ID_TABLE_SEL_COL                       = 751;
  ID_INSERT_PAGE_COUNT                   = 752;
  ID_INSERT_BOOKMARK                     = 753;
  ID_CREATE_FIRST_HDR                    = 754;
  ID_CREATE_FIRST_FTR                    = 755;
  ID_DELETE_FIRST_HDR                    = 756;
  ID_DELETE_FIRST_FTR                    = 757;

  ID_SHOW_FIELD_NAMES                    = 758;
  ID_INSERT_HYPH                         = 759;
  ID_CHAR_SPACE                          = 760;
  ID_INLINE_IME                          = 761;

  ID_TABLE_HDR_ROW                       = 762;
  ID_RETURN                              = 763;
  ID_TABLE_ROW_KEEP                      = 764;
  ID_TABLE_CELL_COLOR                    = 765;
  ID_INSERT_DATA_FIELD                   = 766;
  ID_INSERT_INPUT_FIELD                  = 767;
  ID_INSERT_CHECKBOX                     = 768;
  ID_EDIT_INPUT_FIELD                    = 769;
  ID_INSERT_DATE_TIME                    = 770;
  ID_INSERT_TOC                          = 771;

  ID_LEFT_JUSTIFY                        = 772;
  ID_PAGE_BREAK_BEFORE                   = 773;

  ID_CAPS_ON                             = 774;
  ID_SCAPS_ON                            = 775;
  ID_AUTO_SPELL                          = 776;
  ID_INSERT_ENOTE                        = 777;
  ID_EDIT_ENOTE                          = 778;

  ID_CREATE_LIST                         = 779;
  ID_EDIT_LIST                           = 780;
  ID_CREATE_LIST_OR                      = 781;
  ID_EDIT_LIST_OR                        = 782;
  ID_EDIT_LIST_LEVEL                     = 783;
  ID_PARA_LIST                           = 784;
  ID_LEFT_INDENT_DEC                     = 785;
  ID_TABLE_CELL_BORDER_COLOR             = 786;
  ID_PASTE_TEXT                          = 787;
  ID_TABLE_CELL_WIDTH                    = 788;
  ID_FRAME_ROTATE_TEXT                   = 789;
  ID_PARA_RTL                            = 790;
  ID_TABLE_ROW_RTL                       = 791;
  ID_SECT_RTL                            = 792;
  ID_DOC_RTL                             = 793;
  ID_INSERT_HLINK                        = 794;
  ID_OVERRIDE_BIN                        = 795;
  ID_TRACK_CHANGES                       = 796;
  ID_ULINE_COLOR                         = 797;
  ID_LIST_LEVEL_INC                      = 798;
  ID_LIST_LEVEL_DEC                      = 799;
  ID_BORDER_MARGIN                       = 800;
  ID_PROTECT_FORM                        = 801;
  ID_WATERMARK                           = 802;
  ID_TABLE_CELL_VTEXT                    = 803;
  ID_NEXT_CHANGE                         = 804;
  ID_PREV_CHANGE                         = 805;
  ID_ACCEPT_CHANGE                       = 806;
  ID_ACCEPT_ALL_CHANGES                  = 807;
  ID_USER1                               = 808;
  ID_USER2                               = 809;
  ID_USER3                               = 810;
  ID_USER4                               = 811;
  ID_USER5                               = 812;
  ID_USER6                               = 813;
  ID_USER7                               = 814;
  ID_USER8                               = 815;
  ID_USER9                               = 816;
  ID_DEL_NEXT_WORD                       = 817;
  ID_CHAR_SCALEX                         = 818;
  ID_REJECT_CHANGE                       = 819;
  ID_REJECT_ALL_CHANGES                  = 820;
  ID_VRULER                              = 821;
  ID_PARA_RTL_KEY                        = 822;
  ID_PARA_LTR_KEY                        = 823;

  ID_CREATE_RIGHT_HDR                    = 824;
  ID_CREATE_RIGHT_FTR                    = 825;
  ID_DELETE_RIGHT_HDR                    = 826;
  ID_DELETE_RIGHT_FTR                    = 827;

  ID_CREATE_LEFT_HDR                     = 828;
  ID_CREATE_LEFT_FTR                     = 829;
  ID_DELETE_LEFT_HDR                     = 830;
  ID_DELETE_LEFT_FTR                     = 831;

  ID_DOUBLE_STRIKE_ON                    = 832;
  ID_HIDE_CHANGES                        = 833;
  ID_INSERT_COMBOBOX                     = 834;

  ID_APPLY_COMMENT                       = 835;
  ID_NUM_TO_CHAR                         = 836;
  ID_PAINT_FORMAT                        = 837;
  ID_HILIGHT_TEXT                        = 838;

  ID_INSERT_OLE_FROM_FILE                = 839;
  ID_RESET_CHAR_STYLES                   = 840;
  ID_TABLE_SPLIT                         = 841;

  ID_BULLET_DROPDOWN                     = 842;
  ID_BACK_SPACE                          = 843;

const
  LP_LINE_FLAGS                          =   01;
  LP_LINE_FLAGS2                         =   02;
  LP_LINE_LEN                            =   03;
  LP_LIST_NBR                            =   04;
  LP_LIST_FONT                           =   05;
  LP_CELL_ID                             =   06;
  LP_PARA_FRAME_ID                       =   07;
  LP_LIST_ID                             =   08;
  LP_LIST_OR_ID                          =   09;
  LP_LIST_LEVEL                          =   10;
  LP_LINE_NUM                            =   11;
  LP_PARA_MARK                           =   12;
  LP_LIST_TEXT_WIDTH                     =   13;
  LP_HEIGHT                              =   14;
  LP_LIST_BULLET_SYM                     =   15;
  LP_LIST_TEXT                           =   16;
  LP_PARA_FIRST_LINE                     =   17;
  LP_PARA_LAST_LINE                      =   18;
  LP_SECT_ID                             =   19;
  LP_LIST_TEXT_WIDTH_NO_SPACES           =   20;

  LP_ERROR                               = 9999;

const
  MSG_NO_ERROR                           = 000;
  MSG_BAD_BMP_FILE                       = 001;
  MSG_BAD_FNOTE_MARKER                   = 002;
  MSG_BAD_OBJ_SIZE                       = 003;
  MSG_BAD_PRINTER_DRV                    = 004;
  MSG_CELL_DATA_MISSING                  = 005;
  MSG_CELL_WITHOUT_ROW                   = 006;
  MSG_CHARSTYLE_IN_USE                   = 007;
  MSG_CHAR_FMT_MISSING                   = 008;
  MSG_CLIPBOARD_BUSY                     = 009;
  MSG_CLIPBOARD_NO_DATA                  = 010;
  MSG_CLIPBOARD_NO_FMT                   = 011;
  MSG_COUNT_MISMATCH                     = 012;
  MSG_CREATE_NEW_FILE                    = 013;
  MSG_END_BACKWARD_SEARCH                = 014;
  MSG_END_FORWARD_SEARCH                 = 015;
  MSG_ERR_ADDING_STRING                  = 016;
  MSG_ERR_ADDING_VALUE                   = 017;
  MSG_ERR_ADVISE_CONNECT                 = 018;
  MSG_ERR_ADV_CREATE                     = 019;
  MSG_ERR_BLOCK_SIZE                     = 020;
  MSG_ERR_BMP_CREATE                     = 021;
  MSG_ERR_CTL_CREATE                     = 022;
  MSG_ERR_DATA_RETRIEVE                  = 023;
  MSG_ERR_DIB_CREATE                     = 024;
  MSG_ERR_END_PAGE                       = 025;
  MSG_ERR_END_PRINTER                    = 026;
  MSG_ERR_FILE_LENGTH                    = 027;
  MSG_ERR_FILE_OPEN                      = 028;
  MSG_ERR_FILE_READ                      = 029;
  MSG_ERR_FILE_SEEK                      = 030;
  MSG_ERR_FILE_WRITE                     = 031;
  MSG_SEL_PROTECTED                      = 032;
  MSG_SPELL_OVER                         = 033;
  MSG_STYLESHEET_MISSING                 = 034;
  MSG_TAB_TBL_MISSING                    = 035;
  MSG_TBL_DATA_MISSING                   = 036;
  MSG_TYPE_STYLE_NAME                    = 037;
  MSG_UNDO_EMPTY                         = 038;
  MSG_UNEXPECTED_EOF                     = 039;
  MSG_SEL_SPAN_HDRFTR                    = 040;
  MSG_SECT_TBL_MISSING                   = 041;
  MSG_ERR_FONT_CREATE                    = 042;
  MSG_ERR_FONT_SELECT                    = 043;
  MSG_ERR_INIT_BMP                       = 044;
  MSG_ERR_INIT_OLE                       = 045;
  MSG_ERR_INIT_PRINTER                   = 046;
  MSG_ERR_INSTANCE                       = 047;
  MSG_ERR_LOAD_ACCEL                     = 048;
  MSG_ERR_MAIL_MERGE                     = 049;
  MSG_ERR_MEM_LOCK                       = 050;
  MSG_ERR_META_ACCESS                    = 051;
  MSG_ERR_META_BAD_FILE                  = 052;
  MSG_ERR_META_COPY                      = 053;
  MSG_ERR_META_CREATE                    = 054;
  MSG_ERR_META_READ                      = 055;
  MSG_ERR_META_RECREATE                  = 056;
  MSG_ERR_OBJ_DATA                       = 057;
  MSG_ERR_OBJ_SAVE                       = 058;
  MSG_ERR_OBJ_SIZE                       = 059;
  MSG_ERR_OLE_CLSID                      = 060;
  MSG_ERR_OLE_DATA_CONV                  = 061;
  MSG_ERR_OLE_LOAD                       = 062;
  MSG_ERR_OLE_SAVE                       = 063;
  MSG_ERR_OLE_USER                       = 064;
  MSG_ERR_OLE_VERSION                    = 065;
  MSG_ERR_PEN                            = 066;
  MSG_ERR_PICT_FILE_FMT                  = 067;
  MSG_ERR_PICT_FILE_OPEN                 = 068;
  MSG_ERR_PICT_FILE_READ                 = 069;
  MSG_ERR_PRESENT_DATA                   = 070;
  MSG_ERR_SITE_CREATE                    = 071;
  MSG_ERR_START_PRINTER                  = 072;
  MSG_ERR_STORAGE_CREATE                 = 073;
  MSG_ERR_STORAGE_RETRIEVE               = 074;
  MSG_ERR_TEXT_METRIC                    = 075;
  MSG_ERR_VIEW_RETRIEVE                  = 076;
  MSG_FILE_INFO_MISSING                  = 077;
  MSG_FILE_SIGN_MISSING                  = 078;
  MSG_FONT_TBL_INCOMPL                   = 079;
  MSG_INVALID_NUMBER                     = 080;
  MSG_INVALID_PRINT_RECT                 = 081;
  MSG_INVALID_SECT_DATA                  = 082;
  MSG_INVALID_SELECT                     = 083;
  MSG_KEEP_HDRFTR_LINE                   = 084;
  MSG_LINE_TOO_LONG                      = 085;
  MSG_LINE_TRUNCATED                     = 086;
  MSG_MARGIN_TOO_LARGE                   = 087;
  MSG_MAX_LINES_EXCEEDED                 = 088;
  MSG_MERGE_DATA_TOO_LONG                = 089;
  MSG_MISSING_ROW_MARKER                 = 090;
  MSG_NODEL_HDRFTR_BODY                  = 091;
  MSG_NOT_TE_FILE                        = 092;
  MSG_NO_HILIGHT                         = 093;
  MSG_NO_OLE_CLASS                       = 094;
  MSG_NO_RANGE_PRINTING                  = 095;
  MSG_NO_SERVER                          = 096;
  MSG_NO_STRING                          = 097;
  MSG_NULL_FIELD                         = 098;
  MSG_OLEERR_NEED_SHARE                  = 099;
  MSG_OLEERR_NO_CLASS                    = 100;
  MSG_OUT_OF_CELL_SLOT                   = 101;
  MSG_OUT_OF_CHAR_STACK                  = 102;
  MSG_OUT_OF_COMP_DC                     = 103;
  MSG_OUT_OF_DC                          = 104;
  MSG_OUT_OF_DRAG_OBJ                    = 105;
  MSG_OUT_OF_FONT_SLOT                   = 106;
  MSG_OUT_OF_GROUP                       = 107;
  MSG_OUT_OF_MEM                         = 108;
  MSG_OUT_OF_PARA_SLOT                   = 109;
  MSG_OUT_OF_PARAFID_SLOT                = 110;
  MSG_OUT_OF_RANGE                       = 111;
  MSG_OUT_OF_ROW_SLOT                    = 112;
  MSG_OUT_OF_STYLESHEET                  = 113;
  MSG_OUT_OF_TAB_POS                     = 114;
  MSG_OUT_OF_TAB_TABLE                   = 115;
  MSG_OUT_OF_TASK                        = 116;
  MSG_OUT_OF_WIN_SLOTS                   = 117;
  MSG_PARASTYLE_IN_USE                   = 118;
  MSG_PARA_FMT_MISSING                   = 119;
  MSG_PARA_TBL_INCOMPL                   = 120;
  MSG_PFRAME_DATA_MISSING                = 121;
  MSG_PRINT_AREA_SMALL                   = 122;
  MSG_PROTECTED                          = 123;
  MSG_READ_ABORTED                       = 124;
  MSG_REPLACE_STRING                     = 125;
  MSG_SAVE_INCOMPL                       = 126;
  MSG_SAVE_MODS                          = 127;
  MSG_SECTION_FULL                       = 128;
  MSG_BAD_WIN_HANDLE                     = 129;
  MSG_BAD_VERSION                        = 130;
  MSG_NODEL_MIX_HTML                     = 131;
  MSG_ERR_TOO_MANY_FILES                 = 132;
  MSG_ERR_FILE_ACCESS                    = 133;
  MSG_REDO_EMPTY                         = 134;
  MSG_OUT_OF_BLT_TABLE                   = 135;
  MSG_BULLET_MISSING                     = 136;
  MSG_BAD_JPG_FILE                       = 137;
  MSG_ERR_JPG_HUFF                       = 138;
  MSG_ERR_JPG_MARKER                     = 139;
  MSG_ERR_JPG_NO_HUFF                    = 140;
  MSG_TAG_TABLE_MISSING                  = 141;
  MSG_ERR_ENH_META_HDR                   = 142;
  MSG_GET_ENH_META                       = 143;
  MSG_MAX_WIN_LINES                      = 144;
  MSG_SOFT_PAGE_BREAK                    = 145;
  MSG_SECT_BREAK                         = 146;
  MSG_PAGE_BREAK                         = 147;
  MSG_COL_BREAK                          = 148;
  MSG_PAGE_HDR                           = 149;
  MSG_PAGE_FTR                           = 150;
  MSG_ROW_BREAK                          = 151;
  MSG_DEL_DRAW_OBJ                       = 152;
  MSG_DEL_FRAME                          = 153;
  MSG_IRREVERSIBLE_DEL                   = 154;
  MSG_ERR_PRINT                          = 155;
  MSG_FIRST_HDR                          = 156;
  MSG_FIRST_FTR                          = 157;
  MSG_DEL_FIRST_HDR                      = 158;
  MSG_DEL_FIRST_FTR                      = 159;
  MSG_BAD_PNG_DATA                       = 160;
  MSG_PRINTING_CANCELLED                 = 161;
  MSG_SMALL_CELL_MARGIN                  = 162;
  MSG_READ_ONLY                          = 163;
  MSG_NO_PRINTER                         = 164;
  MSG_DEL_TOC                            = 165;
  MSG_NO_RTF_INFO_BLOCK                  = 166;
  MSG_NO_LIST_BLOCK                      = 167;
  MSG_NO_LIST_OR_BLOCK                   = 168;
  MSG_DEL_HDR                            = 169;
  MSG_DEL_FTR                            = 170;
  MSG_ERR_JPG_MCU                        = 171;
  MSG_OUT_OF_IMAGE_MAP_TABLE             = 172;
  MSG_COLUMNS                            = 173;
  MSG_GIF_FILES                          = 174;
  MSG_ENH_METAFILES                      = 175;
  MSG_BMP_FILES                          = 176;
  MSG_METAFILES                          = 177;
  MSG_JPG_FILES                          = 178;
  MSG_PNG_FILES                          = 179;
  MSG_PICTURE_SIZE                       = 180;
  MSG_SINGLE                             = 181;
  MSG_15LINES                            = 182;
  MSG_DBL_LINE                           = 183;
  MSG_EXACTLY                            = 184;
  MSG_MULTIPLE                           = 185;
  MSG_LINES                              = 186;
  MSG_POINTS                             = 187;
  MSG_TAB_POS                            = 188;
  MSG_MARGIN                             = 189;
  MSG_PNG_ABORT                          = 190;
  MSG_FATAL_ERROR                        = 191;
  MSG_FILE_OPEN                          = 192;
  MSG_ERROR                              = 193;
  MSG_SPL_DONE                           = 194;
  MSG_BAD_RTF                            = 195;
  MSG_UNKNOWN                            = 196;
  MSG_ATLEAST                            = 197;
  MSG_PAGE_BOX                           = 198;
  MSG_IGNORE_ALL                         = 199;
  MSG_ADD                                = 200;
  MSG_SB_INS                             = 201;
  MSG_SB_OT                              = 202;
  MSG_SB_PAGE                            = 203;
  MSG_SB_LINE                            = 204;
  MSG_SB_ROW                             = 205;
  MSG_SB_COL                             = 206;
  MSG_PP_ONE_PAGE                        = 207;
  MSG_PP_TWO_PAGES                       = 208;
  MSG_PP_PRINT                           = 209;
  MSG_PP_EDIT                            = 210;
  MSG_PP_PG                              = 211;
  MSG_PP_FITTED                          = 212;
  MSG_TIFF                               = 213;
  MSG_TIF_FILES                          = 214;
  MSG_INVOKE_TEXT_LINK                   = 215;
  MSG_NO_REVIEWER_BLOCK                  = 216;
  MSG_INSERTED_BY                        = 217;
  MSG_DELETED_BY                         = 218;
  MSG_NO_CHANGED_TEXT                    = 219;
  MSG_ACCEPT_CHANGES                     = 220;
  MSG_CHANGES_COUNT                      = 221;
  MSG_MENU_EDIT_FRAME                    = 222;
  MSG_MENU_EDIT_LIST                     = 223;
  MSG_MENU_EDIT_HDR_FTR                  = 224;
  MSG_MENU_EDIT_FNOTE                    = 225;
  MSG_MENU_EDIT_TRACK                    = 226;
  MSG_MENU_INSERT_BREAK                  = 227;
  MSG_MENU_INSERT_FNOTE                  = 228;
  MSG_REJECT_CHANGES                     = 229;
  MSG_REJECT_COUNT                       = 230;
  MSG_DATA_TOO_BIG                       = 231;
  MSG_PAGE_LHDR                          = 232;
  MSG_PAGE_LFTR                          = 233;
  MSG_PAGE_RHDR                          = 234;
  MSG_PAGE_RFTR                          = 235;
  MSG_XML_READER                         = 236;
  MSG_OLD_XML_LIB                        = 237;
  MSG_HTML_ADD_ON                        = 238;
  MSG_FMT_BY                             = 239;
  MSG_PDF                                = 240;
  MSG_PARA_FMT_BY                        = 241;
  MSG_LOAD_LIBRARY                       = 242;
  MSG_ST_EVAL_EXPIRED                    = 243;
  MSG_ST_BAD_LICENSE                     = 244;
  MSG_OLD_DOC_FILE                       = 245;
  MSG_ENCRYPTED_DOC_FILE                 = 246;
  MSG_ALL_PICT_FILES                     = 247;
  MSG_ENFLATE_ERROR                      = 248;
  MSG_SVG_FILES                          = 249;
  MSG_INVALID_SVG                        = 250;
  MSG_SVG_DLL_NOT_FOUND                  = 251;

const
  PFLAG_FRAME                            = $0001;
  PFLAG_CELL                             = $0002;
  PFLAG_RESERVED1                        = $0004;
  PFLAG_RESERVED2                        = $0008;

  PFLAG_NO_WRAP                          = $0010;
  PFLAG_WIDOW                            = $0020;
  PFLAG_PAGE_BREAK                       = $0040;
  PFLAG_ENDNOTE                          = $0080;
  PFLAG_NO_NUM_LIST                      = $0100;
  PFLAG_NO_SNAP_TO_GRID                  = $0200;

const
  SAVE_TER                               = 0;
  SAVE_TEXT                              = 1;
  SAVE_TEXT_LINES                        = 2;
  SAVE_RTF                               = 3;
  SAVE_DEFAULT                           = 4;
  SAVE_HTML                              = 5;
  SAVE_UTEXT                             = 6;
  SAVE_DOCX                              = 7;
  SAVE_DOC                               = 8;

const
  SEL_CELLS                              = 1;
  SEL_COLS                               = 2;
  SEL_ROWS                               = 3;
  SEL_ALL                                = 4;

const
  TLB_LINE                               = 01;
  TLB_TYPEFACE                           = 02;
  TLB_POINTSIZE                          = 03;
  TLB_BOLD                               = 04;
  TLB_ITALIC                             = 05;
  TLB_ULINE                              = 06;
  TLB_ALIGN_LEFT                         = 07;
  TLB_ALIGN_RIGHT                        = 08;
  TLB_ALIGN_CENTER                       = 09;
  TLB_ALIGN_JUSTIFY                      = 10;
  TLB_INC_INDENT                         = 11;
  TLB_DEC_INDENT                         = 12;
  TLB_STYLE                              = 13;
  TLB_ZOOM                               = 14;
  TLB_CUT                                = 15;
  TLB_COPY                               = 16;
  TLB_PASTE                              = 17;
  TLB_SPACER                             = 18;
  TLB_NEW                                = 19;
  TLB_OPEN                               = 20;
  TLB_SAVE                               = 21;
  TLB_PRINT                              = 22;
  TLB_HELP                               = 23;
  TLB_PAR                                = 24;
  TLB_PREVIEW                            = 25;
  TLB_NUMBER                             = 26;
  TLB_BULLET                             = 27;
  TLB_UNDO                               = 28;
  TLB_REDO                               = 29;
  TLB_FIND                               = 30;
  TLB_DATE                               = 31;
  TLB_PAGE_NUM                           = 32;
  TLB_PAGE_COUNT                         = 33;
  TLB_PAINT_FORMAT                       = 34;
  TLB_BULLET_DROPDOWN                    = 35;

const
  TP_TOTAL_LINES                         = 01;
  TP_TOTAL_PFMTS                         = 02;
  TP_TOTAL_FONTS                         = 03;
  TP_TOTAL_STYLES                        = 04;
  TP_TOTAL_PAGES                         = 05;
  TP_TOTAL_PARA_FRAMES                   = 06;
  TP_TOTAL_CHAR_TAGS                     = 07;
  TP_TOTAL_IMAGE_MAPS                    = 08;
  TP_TOTAL_BLTS                          = 09;
  TP_TOTAL_LISTS                         = 10;
  TP_TOTAL_LIST_OR                       = 11;
  TP_TOTAL_TABS                          = 12;
  TP_TOTAL_TABLE_ROWS                    = 13;
  TP_TOTAL_CELLS                         = 14;
  TP_TOTAL_SECTS                         = 15;
  TP_CUR_LINE                            = 16;
  TP_CUR_COL                             = 17;
  TP_CUR_SECT                            = 18;
  TP_SELECTION_TYPE                      = 19;
  TP_SELECTION_START_LINE                = 20;
  TP_SELECTION_START_COL                 = 21;
  TP_SELECTION_END_LINE                  = 22;
  TP_SELECTION_END_COL                   = 23;
  TP_WATERMARK_WASH                      = 24;
  TP_WATERMARK_PICT                      = 25;
  TP_PAGE_BK_COLOR                       = 26;
  TP_TOTAL_REVIEWERS                     = 27;
  TP_MOUSE_ON_TEXT_LINE                  = 28;
  TP_WIN_ORG_Y                           = 30;

  TP_MOUSE_FIRST                         = 31;
  TP_MOUSE_X                             = 31;
  TP_MOUSE_Y                             = 32;
  TP_MOUSE_LINE                          = 33;
  TP_MOUSE_COL                           = 34;
  TP_MOUSE_FONT_ID                       = 35;
  TP_MOUSE_PICT_ID                       = 36;
  TP_MOUSE_FIELD_ID                      = 37;
  TP_MOUSE_FRAME_ID                      = 38;
  TP_MOUSE_COMMENT_ID                    = 39;
  TP_MOUSE_LAST                          = 39;

  TP_DEF_CHARSET                         = 60;
  TP_TOTAL_CHARS                         = 61;
  TP_PREVIEW_ZOOM_PCT                    = 62;
  TP_TABLE_COLS_SELECTED                 = 63;
  TP_TABLE_ROWS_SELECTED                 = 64;
  TP_HAS_TRACK_CHANGES                   = 65;
  TP_CUR_REV_ID                          = 66;
  TP_INIT_LIST_INDENT                    = 67;
  TP_FIXED_BULLET_SIZE                   = 68;
  TP_DRAGGING_TEXT                       = 69;
  TP_SHOW_HIDDEN_TEXT                    = 70;
  TP_TEXT_DEF_BK_COLOR                   = 71;
  TP_JUST_LINE_BREAK_LINE                = 72;
  TP_UNDO_REF                            = 73;
  TP_EMF_SCALE_PCT                       = 74;
  TP_USE_W2016_FEATURES                  = 76;

const
  TFLAG_RESIZE_BITMAP                    = $00000001;
  TFLAG_METRIC                           = $00000002;
  TFLAG_RETURN_MSG_ID                    = $00000004;
  TFLAG_APPLY_PRT_ORIENT                 = $00000008;
  TFLAG_APPLY_PRT_PROPS                  = $00000008;
  TFLAG_IGNORE_PICT_LINK                 = $00000010;
  TFLAG_DISABLE_ACCEL                    = $00000020;
  TFLAG_USE_NEXT_ID                      = $00000040;
  TFLAG_SHOW_CARET                       = $00000080;
  TFLAG_UNPROTECTED_DEL                  = $00000100;
  TFLAG_NO_HOUR_GLASS                    = $00000200;
  TFLAG_NO_CHILD_TOP                     = $00000400;
  TFLAG_NO_WRAP                          = $00000800;
  TFLAG_ACTIVATE_MDI_CHILD               = $00001000;
  TFLAG_COMP_WORD97                      = $00002000;
  TFLAG_EXCLUDE_HIDDEN_SEL               = $00004000;
  TFLAG_AUTO_VSCROLL_BAR                 = $00008000;
  TFLAG_NO_PALETTE                       = $00010000;
  TFLAG_KEEP_PICT_ASPECT                 = $00020000;
  TFLAG_KEEP_FRAME_ASPECT                = $00040000;
  TFLAG_PICT_IN_FRAME                    = $00080000;
  TFLAG_NO_PRINTER                       = $00100000;
  TFLAG_NO_DRAG_TEXT                     = $00200000;
  TFLAG_NO_EDIT_OLE                      = $00400000;
  TFLAG_BETTER_256                       = $00800000;
  TFLAG_NO_EDIT_PICT                     = $01000000;
  TFLAG_SHOW_BREAKS                      = $02000000;
  TFLAG_SELECT_FULL_HLINK                = $04000000;
  TFLAG_BUF_DISP                         = $08000000;
  TFLAG_NO_OLE                           = $10000000;
  TFLAG_ROW_PASTE                        = $20000000;
  TFLAG_NO_AUTO_FULL_CELL_SEL            = $40000000;
  TFLAG_SWAP_DECIMAL                     = $80000000;

  TFLAG2_COMP_WPF                        = $00000001;
  TFLAG2_RETAIN_BKND                     = $00000002;
  TFLAG2_USE_PAL_FOR_TEXT                = $00000004;
  TFLAG2_CAN_MERGE_PROT_TEXT             = $00000008;
  TFLAG2_BKPICT_OVER_PAGE_BORDER         = $00000010;
  TFLAG2_XPARENT_WRITE                   = $00000020;
  TFLAG2_NO_CARET                        = $00000040;
  TFLAG2_SHOW_SECT_PAGE_NO               = $00000080;
  TFLAG2_NO_CURSOR_CHANGE                = $00000100;
  TFLAG2_VERT_THUMB_TRACK                = $00000200;
  TFLAG2_NO_AUTO_REPAGE                  = $00000400;
  TFLAG2_NO_BKP_FILE                     = $00000800;
  TFLAG2_SELECT_FRAME_PICT               = $00001000;
  TFLAG2_HIDE_PAGE_BREAK                 = $00002000;
  TFLAG2_PROTECT_FORMAT                  = $00004000;
  TFLAG2_NO_HIDDEN_RTF_TEXT              = $00008000;
  TFLAG2_NO_SHADE_FIELD_TEXT             = $00010000;
  TFLAG2_IGNORE_TIMER                    = $00020000;
  TFLAG2_NO_AUTO_HDR_FTR                 = $00040000;
  TFLAG2_WRITE_FIRST_RTF_COLOR           = $00080000;
  TFLAG2_FULL_REPAINT                    = $00100000;
  TFLAG2_KEEP_PRINTER_OPEN               = $00200000;
  TFLAG2_ALT_PARA_SYM                    = $00400000;
  TFLAG2_ALT_LINE_SYM                    = $00800000;
  TFLAG2_NO_LINE_FITTING                 = $01000000;
  TFLAG2_NO_PRT_CANCEL_DLG               = $02000000;
  TFLAG2_INDENT_FRAMES                   = $04000000;
  TFLAG2_INDENT_TABLES                   = $08000000;
  TFLAG2_NO_ADJUST_CURSOR                = $10000000;
  TFLAG2_CURSOR_BEF_HIDDEN               = $20000000;
  TFLAG2_NO_CURSOR_ON_PROTECT            = $40000000;

  TFLAG3_WRAP_SPACES                     = $00000001;
  TFLAG3_NO_EDIT_TABLE_COL               = $00000002;
  TFLAG3_TABLE_STATUS_LINE               = $00000004;
  TFLAG3_PLAIN_TABLE_BORDER              = $00000008;
  TFLAG3_GRAY_READ_ONLY                  = $00000010;
  TFLAG3_CURSOR_IN_CELL                  = $00000020;
  TFLAG3_EXACT_CELL_WIDTH                = $00000040;
  TFLAG3_NO_SCROLL                       = $00000080;
  TFLAG3_NO_FULL_CELL_COPY               = $00000100;
  TFLAG3_HTML_CONT_TABLE                 = $00000200;
  TFLAG3_SELECT_FIRST_FIELD              = $00000400;
  TFLAG3_MULTIPLE_RTF_GROUPS             = $00000800;
  TFLAG3_OLD_WORD_FORMAT                 = $00001000;
  TFLAG3_EMBEDDED_TABLES                 = $00002000;
  TFLAG3_DATA_FIELD_INPUT                = $00004000;
  TFLAG3_GET_BUF_HDR_FTR                 = $00008000;
  TFLAG3_HTML_READ                       = $00010000;
  TFLAG3_NO_RTF_BKND_COLOR               = $00020000;
  TFLAG3_NO_SAVE_UNDO                    = $00040000;
  TFLAG3_LARGE_PARA_BORDER               = $00080000;
  TFLAG3_STYLES_ON_TOOLBAR               = $00100000;
  TFLAG3_SHOW_FRAMES                     = $00200000;
  TFLAG3_LINE_SCROLL                     = $00400000;
  TFLAG3_PRINT_BKND_PICT                 = $00800000;
  TFLAG3_PASTE_RTF_CODE                  = $01000000;
  TFLAG3_CLIP_CELL_OVERFLOW              = $02000000;
  TFLAG3_EXACT_SCREEN_FONT               = $04000000;
  TFLAG3_ZERO_CELL_HEIGHT                = $08000000;
  TFLAG3_READ_PNG                        = $10000000;
  TFLAG3_NO_TEXT_COLOR_ADJ               = $20000000;
  TFLAG3_NO_MOUSE_SEL                    = $40000000;

  TFLAG4_COUNT_PCHAR_AS_CRLF             = $00000001;
  TFLAG4_SKIP_PROT_TEXT                  = $00000002;
  TFLAG4_HIDE_HIDDEN_PARA_MARK           = $00000004;
  TFLAG4_READONLY_CONTROLS               = $00000008;
  TFLAG4_NO_REPAGINATE                   = $00000010;
  TFLAG4_SMOOTH_SCROLL                   = $00000020;
  TFLAG4_NO_BUFFERED_SCROLL              = $00000040;
  TFLAG4_TEXT_HIDDEN                     = $00000080;
  TFLAG4_AUTO_SPELL                      = $00000100;
  TFLAG4_BINARY_RTF_PICT                 = $00000200;
  TFLAG4_UNDO_WINDOW_OVERFLOW            = $00000400;
  TFLAG4_IME_UNICODE                     = $00000800;
  TFLAG4_MOD_END_MARK_FONT               = $00001000;
  TFLAG4_ONE_ROW_TOOLBAR                 = $00002000;
  TFLAG4_NO_OLE_DROP                     = $00004000;
  TFLAG4_REPORT_EASE_MODE                = $00008000;
  TFLAG4_ALWAYS_INVOKE_OLE               = $00010000;
  TFLAG4_DISABLE_DATE_UPDATE             = $00020000;
  TFLAG4_SAVE_BMP_AS_PNG                 = $00040000;
  TFLAG4_SAVE_SHAPE_WITH_DRAW_OBJECT     = $00080000;
  TFLAG4_HTML_INPUT                      = $00100000;
  TFLAG4_NO_DRAG_PROT_TEXT               = $00200000;
  TFLAG4_FULL_DRAG_PROT_TEXT             = $00400000;
  TFLAG4_NO_MERGE_TABLE                  = $00800000;
  TFLAG4_NO_TOC_UPDATE                   = $01000000;
  TFLAG4_NO_RESET_DC                     = $02000000;
  TFLAG4_NO_SHARE_BORDER                 = $04000000;
  TFLAG4_ADJ_LEFT_TABLE_COL              = $08000000;
  TFLAG4_DONT_FIX_NEG_INDENT             = $10000000;
  TFLAG4_PASTE_LAST_PARA_PROP            = $20000000;
  TFLAG4_PRINT_WMF_AS_BMP                = $40000000;

  TFLAG5_NO_EXT_DROP                     = $00000001;
  TFLAG5_GROUP_UNDO                      = $00000002;
  TFLAG5_NO_EXACT_ROW_HEIGHT             = $00000004;
  TFLAG5_RTL_CURSOR                      = $00000008;
  TFLAG5_NO_KB_SEL                       = $00000010;
  TFLAG5_WRITE_DOB                       = $00000020;
  TFLAG5_NO_OBJ_IN_STATUS_LINE           = $00000040;
  TFLAG5_NO_CLEAR_SPL_HIST               = $00000080;
  TFLAG5_NO_NORMALIZE_FNOTE              = $00000100;
  TFLAG5_INPUT_TO_UNICODE                = $00000200;
  TFLAG5_NO_NORMALIZE_FIELD              = $00000400;
  TFLAG5_BEF_AND_AFT_HIDDEN              = $00000800;
  TFLAG5_NO_DRAW_IMAGE                   = $00001000;
  TFLAG5_SHOW_PAGE_SETUP                 = $00002000;
  TFLAG5_FULL_REPAGINATE                 = $00004000;
  TFLAG5_PNG_RGB                         = $00008000;
  TFLAG5_NO_SHOW_SPACE_SYM               = $00010000;
  TFLAG5_OLD_HLINK                       = $00020000;
  TFLAG5_NO_DRAG_ROW_LINE                = $00040000;
  TFLAG5_NO_SHARE                        = $00080000;
  TFLAG5_SHOW_PAGE_BREAK                 = $00100000;
  TFLAG5_VARIABLE_PAGE_SIZE              = $00200000;
  TFLAG5_SAVE_PICT_AS_WMF                = $00400000;
  TFLAG5_NO_DRAG_CELL_LINE               = $00800000;
  TFLAG5_RULER_INDENT_FIXED              = $01000000;
  TFLAG5_TOP_ROW_TOOLBAR                 = $02000000;
  TFLAG5_NO_ADJ_FOR_TABLE                = $04000000;
  TFLAG5_UNLIMITED_OLE_SPACE             = $08000000;
  TFLAG5_OLD_RULER                       = $10000000;
  TFLAG5_FRAME_TEXT_ONLY                 = $20000000;
  TFLAG5_PROTECT_DATA_FIELD              = $40000000;

  TFLAG6_USE_PEN_FOR_BORDER              = $00000001;
  TFLAG6_WRITE_DBCS                      = $00000002;
  TFLAG6_WRITE_DEFAULT_COLOR             = $00000004;
  TFLAG6_HI_RES                          = $00000008;
  TFLAG6_DONT_WRITE_PICT_PATH            = $00000010;
  TFLAG6_DONT_PROCESS_TAB                = $00000020;
  TFLAG6_SHOW_PICT_IN_PIXEL_SIZE         = $00000040;
  TFLAG6_DONT_PROCESS_BULLET_KEYS        = $00000080;
  TFLAG6_XLATE_UNICODE                   = $00000100;
  TFLAG6_IN_TEST_MODE                    = $00000200;
  TFLAG6_IN_PLACE_ACTIVATE               = $00000400;
  TFLAG6_ALLOW_CELL_OVERFLOW             = $00000800;
  TFLAG6_INSERT_DROP_PICT_AS_LINK        = $00001000;
  TFLAG6_WRAP_AT_WINDOW_WIDTH            = $00002000;
  TFLAG6_SAVE_TEXT_BK_COLOR              = $00004000;
  TFLAG6_LIST_TO_TEXT_IN_HTML            = $00008000;
  TFLAG6_SUPPORT_DRAGON_SPEECH           = $00010000;
  TFLAG6_NO_LINK_MSG                     = $00020000;
  TFLAG6_NO_TRACK_MSG                    = $00040000;
  TFLAG6_OLE_DROP_SOURCE                 = $00080000;
  TFLAG6_CENTER_DLGS_ON_SCR              = $00100000;
  TFLAG6_PRINT_EMF_AS_BMP                = $00200000;
  TFLAG6_PASTE_UNICODE                   = $00400000;
  TFLAG6_ALT_UNI_CHARWIDTH               = $00800000;
  TFLAG6_TRACK_API                       = $01000000;
  TFLAG6_MBCS_HTML_OUTPUT                = $02000000;
  TFLAG6_SWAP_CR_LINE_BREAK              = $04000000;
  TFLAG6_USE_ANSI_FONT                   = $08000000;
  TFLAG6_WORDPAD_COMPATIBLE_PICT         = $10000000;
  TFLAG6_DEL_CELL_TEXT                   = $20000000;
  TFLAG6_RIGHT_JUST_RTL                  = $40000000;

  TFLAG7_NO_RTL_FONT                     = $00000001;
  TFLAG7_V8_NUMBERING                    = $00000002;
  TFLAG7_ALT_BKSP                        = $00000004;
  TFLAG7_SKIP_HIDDEN_PARA_NBR            = $00000008;
  TFLAG7_AUTO_NEW_ROW                    = $00000010;
  TFLAG7_HIDE_TC_FIELD                   = $00000020;
  TFLAG7_SKIP_WORD_WRAP                  = $00000040;
  TFLAG7_DRAW_OLD_VSCROLL                = $00000080;
  TFLAG7_ALT_HILIGHT_METHOD              = $00000100;
  TFLAG7_OLD_PICT_IN_FRAME               = $00000200;
  TFLAG7_NO_TRACK_CHANGE_LINE            = $00000400;
  TFLAG7_SHRINK_PICT_TO_PAGE             = $00000800;
  TFLAG7_SP                              = $00001000;
  TFLAG7_ANCHOR_WITHIN_PARA              = $00001000;
  TFLAG7_AUTO_PARA_RTL                   = $00002000;
  TFLAG7_SHOW_SPACES_AT_PARA_END         = $00004000;
  TFLAG7_DISABLE_RULER                   = $00008000;
  TFLAG7_AUTO_SET_RTL                    = $00010000;
  TFLAG7_ALWAYS_FIRE_MODIFY              = $00020000;
  TFLAG7_WRITE_LISTTEXT                  = $00040000;
  TFLAG7_EXT_DROP_COPY                   = $00080000;
  TFLAG7_INT_DROP_MOVE                   = $00100000;
  TFLAG7_SET_BOX_CLIPPING                = $00200000;
  TFLAG7_PASTE_OBJECT                    = $00400000;
  TFLAG7_NO_SPELLCHECK_FIELDS            = $00800000;
  TFLAG7_DRAGON_SPEECH_FOCUS             = $01000000;
  TFLAG7_RECORD_CUR_PARA_PROPS           = $02000000;
  TFLAG7_RECORD_CUR_CHAR_PROPS           = $04000000;
  TFLAG7_COMP_TE13                       = $08000000;
  TFLAG7_NO_INTERNET                     = $10000000;
  TFLAG7_NO_TABLE_AUTO_WIDTH             = $20000000;
  TFLAG7_LOAD_EMPTY_TEXT_FIELD           = $40000000;

  TFLAG8_AUTO_REFORMAT_TABLES            = $00000001;
  TFLAG8_HIDE_EMPTY_CELLS_ON_PRINT       = $00000002;
  TFLAG8_DONT_SELECT_LAST_CHAR           = $00000004;
  TFLAG8_ENABLE_GDIPLUS                  = $00000008;
  TFLAG8_USE_PRINTER_FONTS               = $00000010;
  TFLAG8_FIX_NEG_INDENT                  = $00000020;
  TFLAG8_IGNORE_LASTROW                  = $00000040;
  TFLAG8_HIDE_PAGE_BLANK_AREA            = $00000080;
  TFLAG8_HTML_TEXT                       = $00000100;
  TFLAG8_NO_BOX_CLIPPING                 = $00000200;
  TFLAG8_WRAP_ON_HYPHEN                  = $00000400;
  TFLAG8_MERGE_TABLES_ON_PASTE           = $00000800;
  TFLAG8_INSERT_ROWS_ON_PASTE            = $00001000;
  TFLAG8_COMP_V14                        = $00002000;
  TFLAG8_NO_TWIPS                        = $00004000;
  TFLAG8_HTML_RTF_CONV                   = $00008000;
  TFLAG8_GET_MOUSELEAVE                  = $00010000;
  TFLAG8_WRITE_HTML_BULLET_CHAR          = $00020000;
  TFLAG8_WRITE_DOC_RTF                   = $00040000;
  TFLAG8_DISABLE_ALT_RTF_FONT            = $00080000;
  TFLAG8_WRITE_HTML_OBJECT               = $00100000;
  TFLAG8_ALLOW_NARROW_PAGE               = $00200000;
  TFLAG8_DONT_CREATE_BITMAP              = $00400000;
  TFLAG8_WRITE_MERGE_TAG                 = $00800000;
  TFLAG8_DONT_HIDE_HIDDEN_CHAR           = $01000000;
  TFLAG8_DONT_SPELL_CHECK_HDR_FTR        = $02000000;
  TFLAG8_GET_TRACKING_CODES              = $04000000;
  TFLAG8_NO_GDIPLUS_FOR_EMF              = $08000000;
  TFLAG8_HIDE_PPV_EDIT_BUTTON            = $10000000;
  TFLAG8_ALLOW_TEXT_BEF_PROT_FIELD       = $20000000;
  TFLAG8_DONT_USE_KB_LANG                = $40000000;

  TFLAG9_SKIP_STRIKE_TEXT                = $00000001;
  TFLAG9_FIRE_FONT_CHECK                 = $00000002;
  TFLAG9_NO_NESTED_TABLE_WIDTH_ADJ       = $00000004;
  TFLAG9_WRAP_LONG_HTML_WORD             = $00000008;
  TFLAG9_TREAT_DATA_FIELD_AS_ATOM        = $00000010;
  TFLAG9_NO_COMMENTS                     = $00000020;
  TFLAG9_OLD_TABLE_WIDTH_CALC            = $00000040;
  TFLAG9_SHRINK_LIST_TABLE               = $00000080;
  TFLAG9_ALWAYS_WRITE_ROW_PROPS          = $00000100;
  TFLAG9_NO_SHADE_DYNAMIC_FIELDS         = $00000200;
  TFLAG9_SAME_CURSOR_POS_AFTER_ZOOM      = $00000400;
  TFLAG9_ALWAYS_FIRE_STATUS_EVENT        = $00000800;
  TFLAG9_ALWAYS_EMBED_TABLES             = $00001000;
  TFLAG9_NEW_RTF_LISTS                   = $00002000;
  TFLAG9_TOC_TO_TEXT                     = $00004000;
  TFLAG9_CONVERT_COMBO_BOX               = $00008000;
  TFLAG9_DONT_PASTE_TAGS                 = $00010000;
  TFLAG9_ENABLE_POPUP_MENU               = $00020000;
  TFLAG9_USE_ORIG_JPG_FOR_PDF            = $00040000;
  TFLAG9_RETAIN_PROTECT_STYLE            = $00080000;
  TFLAG9_DONT_COLOR_PARA_SPACING         = $00100000;
  TFLAG9_WORD2007_PAGE_BREAK             = $00200000;
  TFLAG9_FORCE_STYLE                     = $00400000;
  TFLAG9_SHOW_FIELD                      = $00800000;
  TFLAG9_RTL_UNICODE_FILE                = $01000000;
  TFLAG9_CLIP_PICTURE                    = $02000000;
  TFLAG9_DONT_COUNT_LAST_BLANK_PAGE      = $04000000;
  TFLAG9_DONT_PROTECT_PARA_BEF_TABLE     = $08000000;
  TFLAG9_FIRE_ADJUST_COLOR               = $10000000;
  TFLAG9_HIDE_PRINT_BUTTON               = $20000000;
  TFLAG9_INVOKE_HYPERLINK                = $40000000;

  TFLAG10_DONT_MARK_WITH_SEL_COL         = $00000001;
  TFLAG10_DONT_USE_BKSP_FONT             = $00000002;
  TFLAG10_DONT_PAD_TABLE_HEIGHT          = $00000004;
  TFLAG10_MERGE_NESTED_RTF_PROPS         = $00000008;
  TFLAG10_EXTEND_AUTO_VSCROLL            = $00000010;
  TFLAG10_NO_HLINK_BOOKMARK              = $00000020;
  TFLAG10_NO_LAST_PARA_MARKER            = $00000040;
  TFLAG10_DONT_COMBINE_UNDOS             = $00000080;
  TFLAG10_AUTO_HSCROLL_BAR               = $00000100;
  TFLAG10_DOTTED_GRID_LINES              = $00000200;
  TFLAG10_NO_CRLF                        = $00000400;
  TFLAG10_WRITE_FIX_WIDTH_TABLE          = $00000800;
  TFLAG10_USE_LAST_PARA_PROPS            = $00001000;
  TFLAG10_WRITE_DOCX_CUSTOM_TAGS         = $00002000;
  TFLAG10_WRITE_RANDOM_LIST_TMPL_ID      = $00004000;
  TFLAG10_DST                            = $00008000;
  TFLAG10_LOCK_DATA_FIELD                = $00010000;
  TFLAG10_LEGACY_SECT_PROPS              = $00020000;
  TFLAG10_SHRINK_RTF_IMAGES              = $00040000;
  TFLAG10_PREFER_PLACEHOLDER_PICT        = $00080000;
  TFLAG10_NO_PICT_READ_MSG               = $00100000;
  TFLAG10_BOOKMARK_TO_PDF                = $00200000;
  TFLAG10_INSERT_AT_FIELD_DATA_BEGIN     = $00400000;
  TFLAG10_TO_PNG_AT_DISP_SIZE            = $00800000;
  TFLAG10_APPEND_TO_FIELD_DATA           = $01000000;
  TFLAG10_NO_EQ_SUPPORT                  = $02000000;
  TFLAG10_HIDDEN_IN_GROUP                = $04000000;
  TFLAG10_SHOW_HIDDEN_PARA               = $08000000;
  TFLAG10_UPRIGHT_CHARS                  = $10000000;
  TFLAG10_NO_DOCX_ACTIVEX                = $20000000;
  TFLAG10_READONLY_WIN_MSG               = $40000000;

  TFLAG11_NO_AUTO_PARA_STYLE_ON_TEXT     = $00000001;
  TFLAG11_DONT_SHRINK_FONT_TABLE         = $00000002;
  TFLAG11_NO_SHPPICT                     = $00000004;
  TFLAG11_NO_EXACT_LINE_SPACING          = $00000008;
  TFLAG11_NO_CHAR_BKND                   = $00000010;
  TFLAG11_NO_BAD_PTR_CHECK               = $00000020;
  TFLAG11_NO_PASTE_PAPER_PROPS           = $00000040;
  TFLAG11_NO_ALTERNATING_BULLETS         = $00000080;
  TFLAG11_ALWAYS_ENABLE_NEW_CMD          = $00000100;
  TFLAG11_DONT_KEEP_TOGETHER_LONG_TABLES = $00000200;
  TFLAG11_DONT_BALANCE_FAR_EAST_TEXT     = $00000400;
  TFLAG11_NO_GIF_ANIM                    = $00000800;
  TFLAG11_NO_PREF_WIDTH_CALC             = $00001000;
  TFLAG11_NBRS_TO_LEFT                   = $00002000;
  TFLAG11_DONT_FIX_RTF_TABLE             = $00004000;
  TFLAG11_CHAR_UCBASE                    = $00008000;
  TFLAG11_PASTE_RTF_SHPTXT_IN_TABLE      = $00010000;
  TFLAG11_FRAME_BEF_TABLE                = $00020000;
  TFLAG11_NO_INITIAL_FOCUS               = $00040000;
  TFLAG11_NO_TAB_CHAR                    = $00080000;
  TFLAG11_NO_DEFAULT_SHPTXT              = $00100000;
  TFLAG11_SHRINK_SUBTABLE_TO_FIT         = $00400000;
  TFLAG11_NO_RIGHT_INDENT_TABLES         = $00800000;
  TFLAG11_TOC_NO_TAB                     = $01000000;
  TFLAG11_NO_REPAGE_IN_SHRINK_IMAGES     = $02000000;
  TFLAG11_VISIBLE_COL_ON_STAT_LINE       = $04000000;

type
  TStrTerField = Record
    {*********************************************************************
    The following fields are read/write fields. To update a field,
    you must retrieve the current values by calling the GetTerFields function.
    Modify the fields that you wish to, and then call the SetTerFields
    function to make the new value effective.
    *********************************************************************}
    size: Integer;               {size of the structure used for version matching}

    CurCol,                      {current window column position}
    PaintEnabled,                {false=disables the painting and word wrapping}
    WrapFlag: Integer;           {wrap control, see WRAP_ constants}

    CurRow,                      {current window row position}
    BeginLine,                   {line number of the first window line}
    CurLine: Longint;            {current line number in the file}

    TextBkColor,                 {background color for text}
    StatusBkColor,               {background color of the status line}
    StatusColor: TColorRef;      {foreground color of the status line}

    HilightType,                 {line or character block, see HILIGHT_ constants}
    HilightBegCol,               {beginning col}
    HilightEndCol: Integer;      {ending col}

    HilightBegRow,               {beginning row}
    HilightEndRow: Longint;      {ending row}

    StretchHilight: Longbool;    {true = highlight being stretch}

    { please do not use following two fields as they are being phased out.
      To get the text and font information, use TerGetLine function instead. }
    text,                                     {line text data, NULL terminated}
    font: Array [0..pred(1000)] of AnsiChar;  {font id for every character in the 'text' array}

    pfmt: Integer;               {paragraph id of the current line}
    LineLen: Integer;            {length of the 'text' array}

    TextApply: Integer;          { use this variable to specify how the 'text'
                                   and 'font' data should be applied to the
                                   current TER window, see APPLY_ constants }

    ReclaimResources: Longbool;  {reuse unused font and para ids}

    ModifyProtectColor,          {modify the color or the protected text}
    LinkDblClick,                {true to activate hyperlink on double click, otherwise use single click}
    ShowProtectCaret: Longbool;  {true to show caret on the protected text}

    LinkStyle: Integer;          {character style of the hyperlink phrase}
    LinkColor: TColorRef;        {color of the linked phrase}

    SnapToGrid: Longbool;        {true to snap ruler items to an invisible grid}

    HtmlMode,                    {true to enable html adjustments}
    ShowTableGridLines: Longbool;{true to show table grid lines}

    {*************************************************************************
     The following are the read only fields.  TER will ignore any
     modification to these fields.
    *************************************************************************}

    hTerWnd: THandle;            {handle to the editor window}
    hTerDC: THandle;             {handle to TER class DC}

    TerRect,                     {entire client window rectangal}
    TerWinRect: TRect;           {text window rectangal}

    TotalLines,                  {total lines in the file}
    MouseLine,                   {text line position of mouse}
    MaxColBlock: Longint;        {biggest column block allowed}

    TotalPfmts,                  {total paragraph ids in use by the current window}
    TotalFonts,                  {Total font objects in use by the current window}
    TotalStyles,                 {Total number of styles}

    WinWidth,                    {current window in columns}
    WinHeight,                   {current window height in number of rows}
    TerWinOrgX,                  {window origin x co-ordinates}
    MouseCol: Integer;           {text column position of mouse}

    modified: Integer;           {data modified, user needs to select the 'save' option to save data }
    WordWrap: Longbool;          {true when wordwrap turned on}

    ParaLeftIndent,              {paragraph left indent in twips}
    ParaRightIndent,             {paragraph right indent in twips}
    ParaFirstIndent,             {paragraph first line indent in twips}
    ParaFlags,                   {paragraph flags,includes such flags as double spacing,centering, right justify etc}
    ParaTabId,                   {paragraph tab id, index into the tab table}
    ParaCellId,                  {paragraph cell id that the paragraph belongs to}
    ParaShading,                 {paragraph shading (0 to 10000)}
    ParaFrameId,                 {paragraph frame id }
    ParaSpaceBefore,             {paragraph space before in twips}
    ParaSpaceAfter,              {paragraph space after in twips}
    ParaSpaceBetween,            {paragraph space between the lines in twips}
    ParaStyleId,                 {paragraph style id}
    ParaAuxId,                   {paragraph aux id}
    pflags: Integer;             {PFLAG_ paragraph flags}

    CurSect: Integer;            {current section number}

    LeftMargin,                  {section left margin in twips}
    RightMargin,                 {section right margin in twips}
    TopMargin,                   {section top margin in twips}
    BotMargin,                   {section bottom margin in twips}
    columns: Integer;            {number of columns in the current section}

    CurPage: Integer;            {current page number}
    TotalPages: Integer;         {total pages}

    MouseX: Integer;             {last mouse x position}
    MouseY: Integer;             {last mouse y position}

    PrintViewW: Longbool;        {true when the print view mode is turned on}
    PageModeW: Longbool;         {true when the page mode is turned on}
    FittedViewW: Longbool;       {true when the fitted view is turned on}
    ShowParaMarkW: Longbool;     {true when showing the paramarkers}
    ShowHiddenTextW: Longbool;   {true when showing the hidden text}

    CurCtlIdW: Integer;          {currently selected control id}
    ParaFrameFlagsW: Integer;    {para frame flags}
  end;

